<script setup lang="ts" generic="T extends string">
    import { ref } from 'vue'
    import { ObjectHistorisedStatus } from '../entities/ObjectHistorisedStatus'

    interface Props {
        objectStatusHistory: ObjectHistorisedStatus<T>[]
    }

    const nbStatusLimit = ref(1)

    defineProps<Props>()
</script>

<template>
    <v-timeline
        v-if="objectStatusHistory"
        class="d-print-none"
        data-cy="object-status-history"
        density="compact"
    >
        <v-timeline-item
            v-for="objectHistorisedStatus in objectStatusHistory.slice(
                0,
                nbStatusLimit
            )"
            :key="objectHistorisedStatus.createdAt.valueOf()"
            data-cy="object-status"
            size="small"
            dot-color="white"
        >
            <p>
                <strong data-cy="object-status-label">{{
                    objectHistorisedStatus.label
                }}</strong>
                par
                <span data-cy="object-status-createdBy">{{
                    objectHistorisedStatus.createdBy
                }}</span>
                <br />
                le
                <span data-cy="object-status-createdAt">
                    {{
                        objectHistorisedStatus.createdAt.toLocaleString(
                            undefined,
                            {
                                dateStyle: 'long',
                                timeStyle: 'medium',
                            }
                        )
                    }}
                </span>
            </p>
            <p v-if="objectHistorisedStatus.comment">
                <em data-cy="object-status-comment">{{
                    objectHistorisedStatus.comment
                }}</em>
            </p>
        </v-timeline-item>
        <v-timeline-item
            v-if="nbStatusLimit < objectStatusHistory.length"
            class="mb-4"
            hide-dot
        >
            <v-btn
                size="small"
                variant="outlined"
                color="on-background"
                data-cy="object-status-show-more"
                @click="nbStatusLimit = objectStatusHistory.length"
            >
                Voir tout l'historique
            </v-btn>
        </v-timeline-item>
    </v-timeline>
</template>
